<template>
  <div class="app-container">

    <!-- 查询和其他操作 -->
    <div class="filter-container"> 
      <el-select v-model="listQuery.business" clearable style="width: 200px" class="filter-item" placeholder="请选择业务">
        <el-option  label="保洁" value="保洁" />
        <el-option  label="品类" value="品类" />
        <el-option  label="保姆" value="保姆" />
        <el-option  label="月嫂" value="月嫂" />
        <el-option  label="搬家" value="搬家" />
      </el-select>
      <el-button v-permission="['GET /admin/shop/list']" class="filter-item" type="primary" icon="el-icon-search" @click="handleFilter">查找</el-button>
      <el-button v-permission="['POST /admin/shop/create']" class="filter-item" type="primary" icon="el-icon-edit" @click="handleCreate">添加</el-button> 
    </div>

    <!-- 查询结果 -->
    <el-table v-loading="listLoading" :data="list" element-loading-text="正在查询中。。。" border fit highlight-current-row>
      <el-table-column align="center" label="业务" prop="business" sortable />

      <el-table-column align="center" label="分类" prop="category" />

      <el-table-column align="center" label="明细" prop="item"/>  
      <el-table-column align="center" label="状态" prop="deleted">
        <template slot-scope="scope">
          <span v-if="scope.row.deleted == true">已停用</span>
          <span v-else>正常</span>
        </template>
      </el-table-column>

      <el-table-column align="center" label="操作" width="250" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button v-permission="['POST /admin/shop/update']" type="primary" size="mini" @click="handleUpdate(scope.row)">编辑</el-button> 
        </template>
      </el-table-column>
    </el-table>

    <pagination v-show="total>0" :total="total" :page.sync="listQuery.page" :limit.sync="listQuery.limit" @pagination="getList" />

    <!-- 添加或修改对话框 -->
    <el-dialog :title="textMap[dialogStatus]" :visible.sync="dialogFormVisible">
      <el-form ref="dataForm" :rules="rules" :model="dataForm" status-icon label-position="left" label-width="100px" style="width: 400px; margin-left:50px;">
        <el-form-item label="业务" prop="business">
           <el-select v-model="dataForm.business" clearable style="width: 200px" class="filter-item" placeholder="业务">
            <el-option label="保洁" value="保洁" />
            <el-option label="品类" value="品类" />
            <el-option label="保姆" value="保姆" />
            <el-option label="月嫂" value="月嫂" />
            <el-option label="搬家" value="搬家" />
          </el-select>
        </el-form-item> 
        <el-form-item label="分类" prop="category">
          <el-select v-model="dataForm.category" clearable style="width: 200px" class="filter-item" placeholder="请选择分类">
             <el-option label="日保" value="日保" />
            <el-option label="品类" value="品类" />
            <el-option label="服务" value="服务" />
            <el-option label="改约" value="改约" /> 
          </el-select>
        </el-form-item>

        <el-form-item label="明细" prop="item"> 
          <el-input v-model="dataForm.item" />
        </el-form-item>

        <el-form-item label="状态" prop="deleted">
          <el-select v-model="dataForm.deleted" clearable style="width: 200px" class="filter-item" placeholder="请选择状态">
            <el-option v-for="type in deletedOptions" :key="type.value" :label="type.label" :value="type.value" />
          </el-select>
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button @click="dialogFormVisible = false">取消</el-button>
        <el-button v-if="dialogStatus=='create'" type="primary" @click="createData">确定</el-button>
        <el-button v-else type="primary" @click="updateData">确定</el-button>
      </div>
    </el-dialog>

  </div>
</template>

<script>
import { listCategory, createCategory, updateCategory } from '@/api/statisticsCategory' 
import Pagination from '@/components/Pagination' // Secondary package based on el-pagination
let vm

export default {
  name: 'statisticsCategory',
  components: { Pagination }, 
  data() {
    return {
      list: null,
      total: 0,
      listLoading: true,
      listQuery: { 
        page: 1,
        limit: 20,
        sort: 'id',
        order: 'desc'
      },
      channels: [],
      dataForm: {
        id: undefined,  
        deleted: false, 
      },
      citys: [],
      deletedOptions: [{
        value: false,
        label: '正常'
      }, {
        value: true,
        label: '删除'
      }],
      dialogFormVisible: false,
      dialogStatus: '',
      textMap: {
        update: '编辑',
        create: '创建'
      },
      rules: {
        business: [{ required: true, message: '业务不能为空', trigger: 'blur' }],
        category: [{ required: true, message: '分类不能为空', trigger: 'blur' }],
        item: [{ required: true, message: '明细不能为空', trigger: 'blur' }], 
      },
      downloadLoading: false
    }
  },
  beforeCreate() {
    vm = this
  },
  created() {
    this.getList() 
  },
  methods: {
    getList() {
      this.listLoading = true
      listCategory(this.listQuery).then(response => {
        this.list = response.data.data.list
        this.total = response.data.data.total
        this.listLoading = false
      }).catch(() => {
        this.list = []
        this.total = 0
        this.listLoading = false
      })
    },
    handleFilter() {
      this.listQuery.page = 1
      this.getList()
    },
    resetForm() {
      this.dataForm = {
        id: undefined ,
        deleted: false, 
      }
    },
    handleCreate() {
      this.resetForm()
      this.dialogStatus = 'create'
      this.dialogFormVisible = true
      this.$nextTick(() => {
        this.$refs['dataForm'].clearValidate()
      })
    },
    createData() {
      this.$refs['dataForm'].validate((valid) => {
        if (valid) {
          createCategory(this.dataForm).then(response => {
            this.list.unshift(response.data.data)
            this.dialogFormVisible = false
            this.$notify.success({
              title: '成功',
              message: '创建成功'
            })
          }).catch(response => {
            this.$notify.error({
              title: '失败',
              message: response.data.errmsg
            })
          })
        }
      })
    },
    handleUpdate(row) {
      this.dataForm = Object.assign({}, row)
      this.dialogStatus = 'update'
      this.dialogFormVisible = true
      this.$nextTick(() => {
        this.$refs['dataForm'].clearValidate()
      })
    },
    updateData() {
      this.$refs['dataForm'].validate((valid) => {
        if (valid) {
          updateCategory(this.dataForm).then(() => {
            for (const v of this.list) {
              if (v.id === this.dataForm.id) {
                const index = this.list.indexOf(v)
                this.list.splice(index, 1, this.dataForm)
                break
              }
            }
            this.dialogFormVisible = false
            this.$notify.success({
              title: '成功',
              message: '更新成功'
            })
          }).catch(response => {
            this.$notify.error({
              title: '失败',
              message: response.data.errmsg
            })
          })
        }
      })
    },
    handleDelete(row) {
      deleteShop(row).then(response => {
        this.$notify.success({
          title: '成功',
          message: '删除成功'
        })
        const index = this.list.indexOf(row)
        this.list.splice(index, 1)
      }).catch(response => {
        this.$notify.error({
          title: '失败',
          message: response.data.errmsg
        })
      })
    },
    handleDownload() {
      this.downloadLoading = true
      import('@/vendor/Export2Excel').then(excel => {
        const tHeader = ['问题ID', '问题内容', '问题回复']
        const filterVal = ['id', 'question', 'answer']
        excel.export_json_to_excel2(tHeader, this.list, filterVal, '常见问题信息')
        this.downloadLoading = false
      })
    }
  }
}
</script>
